/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package API;

import API.ServerAdapters.HTTPServer;
import API.ServerAdapters.ServletServer;
import com.sun.grizzly.comet.CometAsyncFilter;
import com.sun.grizzly.http.embed.GrizzlyWebServer;
import com.sun.grizzly.http.servlet.ServletAdapter;
import com.sun.grizzly.tcp.http11.GrizzlyAdapter;
import java.util.HashMap;
import utils.OortDebug;
import utils.OortFileUtils;

/**
 *
 * @author richard
 */
public enum GrizzlyHarness {
instance;
private GrizzlyWebServer Server = null;
/**
 * This is the main entry point for Grizzly Harness. if this is called more than once
 * the entire server will be restarted and the last configuration passed will be the active
 * instance.
 */
public void init(HarnessConfig harnessConfig){

// if the server is currently running stop it
    if(this.Server != null){
        this.Server.stop();
        this.Server = null;
    }
    this.Server = new GrizzlyWebServer(harnessConfig.getPort(),harnessConfig.getRootDirectory());
    

//    SSLConfig sslConfig = new SSLConfig();
//    sslConfig.setKeyStoreFile("/home/richard/Public/SSL/host.key");
//    sslConfig.setTrustStoreFile("/home/richard/Public/SSL/host.cert");
//    sslConfig.createSSLContext();
//
    //sslConfig.setClientMode(true);

//    this.Server.setSSLConfig(sslConfig);
    this.Server.setMaxThreads(harnessConfig.getMaxThreads());
    this.Server.addAsyncFilter(new CometAsyncFilter());
    // Create a default HTTP adapter context
//    HTTPServer hsa = new HTTPServer(harnessConfig.getRootDirectory(), "/");
//    doLoadHTTPServer(hsa);

}

public void startServer(){
    try{
        OortDebug.out.print("About to start server!!!", this);
        this.Server.start();
    }catch(Exception e){e.printStackTrace();}
}
/**
 * Loads a servlet and places the root folder for this servlet at the cannocal location
 * of the Servlet instnace. 
 *
 * @param ssa
 */
public void doLoadServletServer(ServletServer servletServer){
    HashMap<String, ServletAdapter> servletStore = servletServer.getServletAdapters();
    for(String context: servletStore.keySet()){
        ServletAdapter sa = servletStore.get(context);
        String RootFolder = OortFileUtils.getObjectsDirectory(servletStore.get(context));
        sa.setRootFolder(RootFolder);
        loadServletAdapter(sa);
    }
    
}

private void loadServletAdapter(ServletAdapter sa){
    OortDebug.out.print("About to load servlet: "+sa.getContextPath()+" to root folder: "+sa.getRootFolder() , this);

    this.Server.addGrizzlyAdapter(sa, new String[]{sa.getContextPath()});
}

public void doLoadHTTPServer(HTTPServer hsa){
    GrizzlyAdapter ga = hsa.getAdapter();
    String AContext = hsa.getAdapterContext();

    OortDebug.out.print("About to load http server : "+ga+" to context: "+AContext , this);
    this.Server.addGrizzlyAdapter(ga, new String[]{AContext});
}




}
